﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prakt12.DBModels
{
    partial class Teacher
    {
        public string Fio
        {
            get => TeacherName + " " + TeacherPatronymic + " " + TeacherSurname;
        }

        public string getGenderWithLabel
        {
            get => "Пол: " + ((IdGenderNavigation.GenderName == "м") ? "мужской" : "женский");
        }

        public string getBirthDateWithLabel
        {
            get => "Дата рождения: " + TeacherBirthdate.ToShortDateString() + " года";
        }

        public string getEmailWithLabel
        {
            get => "Почта: " + TeacherEmail;
        }

        public string getPhoneNumberWithLabel
        {
            get => "Телефон: " + TeacherPhoneNumber;
        }

        public string WorkTimeWithLabel
        {
            get 
            {
                if(TeacherWorkTime is null)
                {
                    return "Стаж работы: отсутсвует";
                }
                return "Стаж работы:" + YearCalculatorWithLabel((int)TeacherWorkTime)
                    + MonthCalculatorWithLabel((int)TeacherWorkTime);
            }
        }

        public int SummaryVolume
        {
            get
            {
                int summaryVolume = 0;
                foreach (var item in TeachersCourses) 
                {
                    summaryVolume += item.IdCourseNavigation.CourseHoursNumber;
                }
                return summaryVolume;
            }
        }

        public string getSummaryVolumeWithLabel
        {
            get => "Курсы в общем объеме " + SummaryVolume + " часов:";
        }


        private string YearCalculatorWithLabel(int months)
        {
            int years = months / 12;
            if (years == 0) return "";
            if (years == 1) return " " + years + " год";
            if (years >= 2 && years <= 4) return " " + years + " года";
            else return " " + years + " лет";
        }

        private string MonthCalculatorWithLabel(int months)
        {
            int monthesWithoutYears = months % 12;
            if (monthesWithoutYears == 0) return " 0 месяцев";
            if (monthesWithoutYears == 1) return " " + monthesWithoutYears + " месяц";
            if (monthesWithoutYears >= 2 && monthesWithoutYears <= 4) return " " + monthesWithoutYears + " месяца";
            else return " " + monthesWithoutYears + " месяцев";
        }
    }
}
