﻿using Avalonia.Data.Converters;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prakt12.ValueConverters
{
    public class WorkTimeConverter : IValueConverter
    {
        public object? Convert(object? value, Type targetType, object? parameter, CultureInfo culture)
        {
            if (value is null) return "";
            if(value is int)
            {
                return ((int)value).ToString();
            }
            return null;
        }

        public object? ConvertBack(object? value, Type targetType, object? parameter, CultureInfo culture)
        {
            if(value is string)
            {
                int number;
                try
                {
                    number = System.Convert.ToInt32(value);
                }
                catch
                {
                    return 0;
                }
                return number;
            }
            return null;
        }
    }
}
