﻿using ReactiveUI;

namespace Prakt12.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        public MainWindowViewModel()
        {
            ShowInfoAboutTeachersUCViewModel = new ShowInfoAboutTeachersUCViewModel();
            ShowInfoAboutTeachersUCViewModel.ButtonAddNewTeacherWasPressed += _showInfoAboutTeachersUCViewModel_ButtonAddNewTeacherWasPressed;
            AddTeacherUCViewModel = new AddTeacherUCViewModel();
            AddTeacherUCViewModel.AddNewTeacherPageWasClosed += AddTeacherUCViewModel_AddNewTeacherPageWasClosed;
            IsShowingTeachers = true;
            IsShowingAddTeacherPage = false;
        }


        public bool IsShowingTeachers
        {
            get => _isShowingTeachers;
            set => this.RaiseAndSetIfChanged(ref _isShowingTeachers, value);
        }
        public bool IsShowingAddTeacherPage
        {
            get => _isShowingAddTeacherPage;
            set => this.RaiseAndSetIfChanged(ref _isShowingAddTeacherPage, value);
        }

        public ShowInfoAboutTeachersUCViewModel ShowInfoAboutTeachersUCViewModel
        {
            get => _showInfoAboutTeachersUCViewModel;
            set => this.RaiseAndSetIfChanged(ref _showInfoAboutTeachersUCViewModel, value);
        }

        public AddTeacherUCViewModel AddTeacherUCViewModel
        {
            get => _addTeacherUCViewModel;
            set => this.RaiseAndSetIfChanged(ref _addTeacherUCViewModel, value);
        }


        private void _showInfoAboutTeachersUCViewModel_ButtonAddNewTeacherWasPressed()
        {
            IsShowingTeachers = false;
            IsShowingAddTeacherPage = true;
        }
        private void AddTeacherUCViewModel_AddNewTeacherPageWasClosed()
        {
            IsShowingTeachers = true;
            IsShowingAddTeacherPage = false;
            ShowInfoAboutTeachersUCViewModel?.setTeachersListFromDB();
        }


        private bool _isShowingTeachers;
        private bool _isShowingAddTeacherPage;

        private ShowInfoAboutTeachersUCViewModel _showInfoAboutTeachersUCViewModel;

        private AddTeacherUCViewModel _addTeacherUCViewModel;
    }
}