using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Reactive;
using System.Reactive.Linq;
using Prakt12.DBModels;
using Prakt12.Models;
using Prakt12.Views;
using ReactiveUI;

namespace Prakt12.ViewModels
{
	public class ShowInfoAboutTeachersUCViewModel : ViewModelBase
	{
        public ShowInfoAboutTeachersUCViewModel()
        {
			AddNewTeacherCommand = ReactiveCommand.Create<string>(AddNewTeacherCommandRun);
            setTeachersListFromDB();
        }


		public event Action ButtonAddNewTeacherWasPressed;


        public ObservableCollection<Teacher> TeachersCollection
		{
			get => _teachersCollection;
			set => this.RaiseAndSetIfChanged(ref _teachersCollection, value);
		}

		public ReactiveCommand<string, Unit> AddNewTeacherCommand { get; }


		public void AddNewTeacherCommandRun(string param) => ButtonAddNewTeacherWasPressed?.Invoke();


        public async void setTeachersListFromDB()
		{
            TeachersCollection = new ObservableCollection<Teacher>(await ShowInfoAboutTeachersUCModel.GetAllTeachersWithAllInfoFromDB());
        }


        private ObservableCollection<Teacher> _teachersCollection;
	}
}